"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var util_1 = require("util");
var tempy_1 = __importDefault(require("tempy"));
var fs_1 = require("fs");
var _1 = require(".");
var writeFile = (0, util_1.promisify)(fs_1.writeFile);
var readFile = (0, util_1.promisify)(fs_1.readFile);
var mkdir = (0, util_1.promisify)(fs_1.mkdir);
jest.spyOn(process, 'exit').mockImplementation(function (c) { return c; });
describe('web-scripts format', function () {
    var pkgRoot;
    var testFile;
    beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
        var fixtureFile, content;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    jest.clearAllMocks();
                    pkgRoot = tempy_1.default.directory();
                    fixtureFile = (0, path_1.join)(__dirname, '__fixtures__', 'poorly-formatted-file.ts');
                    testFile = (0, path_1.join)(pkgRoot, 'src', 'poorly-formatted-file.ts');
                    return [4, mkdir((0, path_1.join)(pkgRoot, 'src'))];
                case 1:
                    _a.sent();
                    return [4, readFile(fixtureFile)];
                case 2:
                    content = (_a.sent()).toString();
                    return [4, writeFile(testFile, content.replace(/\/\/ prettier-ignore[\n]+/, ''))];
                case 3:
                    _a.sent();
                    return [2];
            }
        });
    }); });
    afterAll(function () { return jest.restoreAllMocks(); });
    it('formats files', function () { return __awaiter(void 0, void 0, void 0, function () {
        var before, after;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, readFile((0, path_1.join)(pkgRoot, 'src', 'poorly-formatted-file.ts'))];
                case 1:
                    before = _a.sent();
                    expect(before.toString().trim()).toBe('export const FOO = "bar"');
                    (0, _1.formatTask)({ name: 'format', path: pkgRoot, restOptions: [] });
                    return [4, readFile((0, path_1.join)(pkgRoot, 'src', 'poorly-formatted-file.ts'))];
                case 2:
                    after = _a.sent();
                    expect(after.toString().trim()).toBe("export const FOO = 'bar';");
                    return [2];
            }
        });
    }); });
});
