"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.testTask = exports.getJestConfig = void 0;
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var debug_1 = __importDefault(require("debug"));
var web_scripts_utils_1 = require("@spotify/web-scripts-utils");
var Paths_1 = require("../Paths");
var dbg = (0, debug_1.default)('web-scripts:test');
function getJestConfig() {
    if (!(0, web_scripts_utils_1.hasConfig)([
        { type: 'file', pattern: 'jest.config.js' },
        { type: 'package.json', property: 'jest' },
    ])) {
        return Paths_1.JEST_CONFIG;
    }
    return null;
}
exports.getJestConfig = getJestConfig;
function testTask(task) {
    var cmd = 'npx';
    var config = task.config || getJestConfig();
    var args = __spreadArray(__spreadArray([
        '--no-install',
        'jest'
    ], (config ? ['--config', config] : []), true), task.restOptions, true);
    dbg('npx args %o', args);
    return cross_spawn_1.default.sync(cmd, args, { stdio: 'inherit' });
}
exports.testTask = testTask;
