var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { default as Debug } from 'debug';
import { default as spawn } from 'cross-spawn';
import { default as promiseSpawn } from 'cross-spawn-promise';
import { bootstrap as czBootstrap } from 'commitizen/dist/cli/git-cz';
import { hasConfig } from '@spotify/web-scripts-utils';
import { typeCheck } from './LintTask';
import { LINT_STAGED_CONFIG } from '../Paths';
export function getLintStagedConfig() {
    if (!hasConfig([
        { type: 'file', pattern: 'lint-staged.config.js' },
        { type: 'file', pattern: '.lintstagedrc*' },
        { type: 'package.json', property: 'lint-staged' },
    ])) {
        return LINT_STAGED_CONFIG;
    }
    return null;
}
var dbg = Debug('web-scripts:commit');
export function precommitTask(task) {
    return __awaiter(this, void 0, void 0, function () {
        var fns, results, _a, _b;
        var _this = this;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    fns = [];
                    if (task.typecheck) {
                        fns.push(typeCheck);
                    }
                    return [4, Promise.all(fns.map(function (fn) { return __awaiter(_this, void 0, void 0, function () {
                            var stdout;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        dbg('Beginning %s task', fn.name);
                                        return [4, fn(task)];
                                    case 1:
                                        stdout = _a.sent();
                                        dbg('Finished %s task', fn.name);
                                        return [2, stdout];
                                }
                            });
                        }); }))];
                case 1:
                    results = _c.sent();
                    _b = (_a = results).push;
                    return [4, lintStaged(task)];
                case 2:
                    _b.apply(_a, [_c.sent()]);
                    return [2, results];
            }
        });
    });
}
export function lintStaged(task) {
    return __awaiter(this, void 0, void 0, function () {
        var config, cmd, args, env, stdout;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    config = getLintStagedConfig();
                    cmd = 'npx';
                    args = __spreadArray(__spreadArray([
                        '--no-install',
                        'lint-staged'
                    ], (config ? ['--config', config] : []), true), task.restOptions, true);
                    dbg('npx args %o', args);
                    env = __assign(__assign({}, process.env), { WEB_SCRIPTS_RUN_TESTS: task.tests.toString() });
                    if (task.eslintConfig) {
                        env.WEB_SCRIPTS_ESLINT_CONFIG = task.eslintConfig;
                    }
                    if (task.jestConfig) {
                        env.WEB_SCRIPTS_JEST_CONFIG = task.jestConfig;
                    }
                    if (task.prettierConfig) {
                        env.WEB_SCRIPTS_PRETTIER_CONFIG = task.prettierConfig;
                    }
                    return [4, promiseSpawn(cmd, args, {
                            stdio: 'inherit',
                            env: env,
                        })];
                case 1:
                    stdout = _a.sent();
                    return [2, (stdout || '').toString()];
            }
        });
    });
}
export function commitTask(task) {
    dbg('running commitizen commit', task.restOptions);
    var cliPath = require
        .resolve('commitizen/package.json')
        .replace('package.json', '');
    Object.assign(process.env, {
        CZ_TYPE: process.env.CZ_TYPE || ' ',
        CZ_SCOPE: process.env.CZ_SCOPE || ' ',
        CZ_SUBJECT: process.env.CZ_SUBJECT || ' ',
        CZ_BODY: process.env.CZ_BODY || ' ',
        CZ_ISSUES: process.env.CZ_ISSUES || ' ',
        CZ_MAX_HEADER_WIDTH: process.env.CZ_MAX_HEADER_WIDTH || 100,
        CZ_MAX_LINE_WIDTH: process.env.CZ_MAX_LINE_WIDTH || 100,
    });
    return czBootstrap({
        cliPath: cliPath,
        config: {
            path: task.path,
        },
    }, __spreadArray([null], task.restOptions, true));
}
export function commitMsgTask(task) {
    var cmd = 'npx';
    var args = __spreadArray([
        '--no-install',
        'commitlint',
        "--config=".concat(task.config),
        "--edit=".concat(task.edit || process.env.HUSKY_GIT_PARAMS)
    ], task.restOptions, true);
    dbg('npx args %o', args);
    return spawn.sync(cmd, args, { stdio: 'inherit' });
}
export function releaseTask(task) {
    var cmd = 'npx';
    var args = __spreadArray(['--no-install', 'semantic-release'], task.restOptions, true);
    dbg('npx args %o', args);
    return spawn.sync(cmd, args, { stdio: 'inherit' });
}
