var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { default as spawn } from 'cross-spawn-promise';
import { default as Debug } from 'debug';
import { hasConfig } from '@spotify/web-scripts-utils';
import { CONSUMING_ROOT, ESLINT_CONFIG } from '../Paths';
import { getPrettierConfig } from './FormatTask';
var dbg = Debug('web-scripts:lint');
export function getEslintConfig() {
    if (!hasConfig([
        { type: 'file', pattern: '.eslintrc.*' },
        { type: 'package.json', property: 'eslintConfig' },
    ])) {
        return ESLINT_CONFIG;
    }
    return null;
}
export function lintTask(task) {
    return __awaiter(this, void 0, void 0, function () {
        var fns;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fns = [eslintRun];
                    if (task.typecheck)
                        fns.push(typeCheck);
                    if (task.stylecheck)
                        fns.push(styleCheck);
                    return [4, Promise.all(fns.map(function (fn) { return __awaiter(_this, void 0, void 0, function () {
                            var stdout;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        dbg('Beginning %s task', fn.name);
                                        return [4, fn(task)];
                                    case 1:
                                        stdout = _a.sent();
                                        dbg('Finished %s task', fn.name);
                                        return [2, stdout];
                                }
                            });
                        }); }))];
                case 1: return [2, _a.sent()];
            }
        });
    });
}
export function eslintRun(task) {
    return __awaiter(this, void 0, void 0, function () {
        var cmd, config, args, stdout;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cmd = 'npx';
                    config = task.config || getEslintConfig();
                    args = __spreadArray(__spreadArray([
                        '--no-install',
                        'eslint',
                        '--ext',
                        'js,ts,jsx,tsx',
                        CONSUMING_ROOT,
                        '--ignore-pattern',
                        'types/',
                        '--ignore-pattern',
                        'cjs/',
                        '--ignore-pattern',
                        'esm/'
                    ], (config ? ['--config', config] : []), true), task.restOptions, true);
                    dbg('npx args %o', args);
                    return [4, spawn(cmd, args, { stdio: 'inherit' })];
                case 1:
                    stdout = _a.sent();
                    return [2, (stdout || '').toString()];
            }
        });
    });
}
export function typeCheck() {
    return __awaiter(this, void 0, void 0, function () {
        var cmd, args, stdout;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cmd = 'npx';
                    args = ['tsc', '--noEmit'];
                    return [4, spawn(cmd, args, { stdio: 'inherit' })];
                case 1:
                    stdout = _a.sent();
                    return [2, (stdout || '').toString()];
            }
        });
    });
}
export function styleCheck() {
    return __awaiter(this, void 0, void 0, function () {
        var cmd, args, config, stdout;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cmd = 'npx';
                    args = ['--no-install', 'prettier'];
                    config = getPrettierConfig();
                    if (config) {
                        args.push('--config', config);
                    }
                    args.push('--check', "".concat(CONSUMING_ROOT, "/**/src/**/*.{ts,tsx,js,jsx}"));
                    return [4, spawn(cmd, args, { stdio: 'inherit' })];
                case 1:
                    stdout = _a.sent();
                    return [2, (stdout || '').toString()];
            }
        });
    });
}
