var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { exec as execCP } from 'child_process';
import { join } from 'path';
import { promisify } from 'util';
import { writeFile as writeFileFS, mkdir as mkdirFS, copyFile as copyFileFS, existsSync, } from 'fs';
import fromEntries from 'object.fromentries';
import * as tempy from 'tempy';
import { default as Debug } from 'debug';
import rimraf from 'rimraf';
import { THIS_ROOT, TSCONFIG } from './Paths';
var dbg = Debug('web-scripts:integration-test');
var root = join(__dirname, '..');
var CLI = join(root, 'bin/web-scripts');
var MONOREPO_ROOT = join(root, '../..');
var ESLINT_ROOT = join(MONOREPO_ROOT, 'packages/eslint-config');
var execPromise = promisify(execCP);
var writeFile = promisify(writeFileFS);
var mkdir = promisify(mkdirFS);
var copyFile = promisify(copyFileFS);
var exec = function (cmd, options) { return __awaiter(void 0, void 0, void 0, function () {
    function _log(resp) {
        if (resp.stdout)
            resp.stdout.toString().split('\n').forEach(dbg);
        if (resp.stderr)
            resp.stderr.toString().split('\n').forEach(dbg);
    }
    var resp, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4, execPromise(cmd, options)];
            case 1:
                resp = _a.sent();
                _log(resp);
                return [2, resp];
            case 2:
                err_1 = _a.sent();
                _log(err_1);
                throw err_1;
            case 3: return [2];
        }
    });
}); };
var SETUP_REPO_TIMEOUT = 30000;
var TEST_SCRIPTS_TIMEOUT = 60000;
describe.skip('integration tests', function () {
    var PKG_ROOT;
    beforeEach(function () {
        PKG_ROOT = tempy.directory();
    });
    describe('help', function () {
        var USAGE_MATCH = 'Usage: web-scripts [options] [command]';
        test('The CLI fails and offers help when invoked with no arguments', function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, expect(exec("".concat(CLI))).rejects.toMatchObject({
                            stdout: expect.stringContaining(USAGE_MATCH),
                        })];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        }); });
        test('The CLI offers help when invoked with --help flag', function () { return __awaiter(void 0, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, exec("".concat(CLI, " --help"))];
                    case 1:
                        result = _a.sent();
                        expect(result.stdout).toMatch(USAGE_MATCH);
                        return [2];
                }
            });
        }); });
    });
    describe('TypeScript', function () {
        beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, setupRepo('index.ts', 'index.test.ts', 'Component.tsx', 'Component.test.tsx')];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        }); }, SETUP_REPO_TIMEOUT);
        test('Full integration test', function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, testScripts()];
                case 1: return [2, _a.sent()];
            }
        }); }); }, TEST_SCRIPTS_TIMEOUT);
    });
    describe('JavaScript', function () {
        beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, setupRepo('index.js', 'index.test.js', 'Component.jsx', 'Component.test.jsx')];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        }); }, SETUP_REPO_TIMEOUT);
        test('Full integration test', function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, testScripts(['--no-types'], ['--no-typecheck'])];
                case 1: return [2, _a.sent()];
            }
        }); }); }, TEST_SCRIPTS_TIMEOUT);
    });
    function setupRepo() {
        var fileNames = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            fileNames[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var localDependencies, eslintDependencies, pkg, tsConfig;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        localDependencies = [
                            'eslint',
                            'ts-jest',
                            'typescript',
                            '@types/jest',
                            '@types/react',
                        ];
                        eslintDependencies = [
                            '@typescript-eslint/eslint-plugin',
                            'eslint-plugin-jest',
                            'eslint-plugin-jsx-a11y',
                            'eslint-plugin-react',
                            'eslint-plugin-react-hooks',
                        ];
                        pkg = {
                            name: 'test-pkg',
                            scripts: {
                                test: "".concat(CLI, " test"),
                                build: "".concat(CLI, " build"),
                                lint: "".concat(CLI, " lint"),
                                commit: "".concat(CLI, " commit"),
                                release: "".concat(CLI, " release"),
                            },
                            dependencies: fromEntries(__spreadArray(__spreadArray(__spreadArray([], Object.entries(require("".concat(THIS_ROOT, "/package.json")).dependencies).filter(function (_a) {
                                var k = _a[0];
                                return localDependencies.includes(k);
                            }), true), Object.entries(require("".concat(ESLINT_ROOT, "/package.json")).dependencies).filter(function (_a) {
                                var k = _a[0];
                                return eslintDependencies.includes(k);
                            }), true), [
                                ['react', '^17'],
                            ], false)),
                        };
                        tsConfig = {
                            extends: TSCONFIG,
                            include: ['src'],
                        };
                        return [4, writeFile(join(PKG_ROOT, 'package.json'), JSON.stringify(pkg, null, '  '))];
                    case 1:
                        _a.sent();
                        return [4, writeFile(join(PKG_ROOT, 'tsconfig.json'), JSON.stringify(tsConfig, null, 2))];
                    case 2:
                        _a.sent();
                        return [4, mkdir(join(PKG_ROOT, 'src'))];
                    case 3:
                        _a.sent();
                        fileNames.map(function (fileName) {
                            return copyFile(join(THIS_ROOT, '__fixtures__', fileName), join(PKG_ROOT, 'src', fileName));
                        });
                        return [4, copyFile(join(MONOREPO_ROOT, '.gitignore'), join(PKG_ROOT, '.gitignore'))];
                    case 4:
                        _a.sent();
                        return [4, exec('yarn', { cwd: PKG_ROOT })];
                    case 5:
                        _a.sent();
                        return [4, exec('git init', { cwd: PKG_ROOT })];
                    case 6:
                        _a.sent();
                        return [2];
                }
            });
        });
    }
    function testScripts(buildArgs, lintArgs) {
        if (buildArgs === void 0) { buildArgs = []; }
        if (lintArgs === void 0) { lintArgs = ['--ignore-path=.gitignore', '--format=checkstyle']; }
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        rimraf.sync(join(PKG_ROOT, 'cjs'));
                        expect(existsSync(join(PKG_ROOT, 'cjs/index.js'))).toBe(false);
                        return [4, exec(__spreadArray(['yarn build'], buildArgs, true).join(' '), { cwd: PKG_ROOT })];
                    case 1:
                        _a.sent();
                        expect(existsSync(join(PKG_ROOT, 'cjs/index.js'))).toBe(true);
                        return [4, exec('yarn test', { cwd: PKG_ROOT })];
                    case 2:
                        _a.sent();
                        return [4, exec('yarn test index.test', { cwd: PKG_ROOT })];
                    case 3:
                        _a.sent();
                        return [4, exec(__spreadArray(['yarn lint'], lintArgs, true).join(' '), { cwd: PKG_ROOT })];
                    case 4:
                        _a.sent();
                        return [3, 6];
                    case 5:
                        e_1 = _a.sent();
                        console.log(e_1.stdout);
                        throw e_1;
                    case 6: return [2];
                }
            });
        });
    }
});
